/* 
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

  STARTER PROGRAM

 * Section AA
 *
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS 	8


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_TRAFFIC	25

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40

/*Facial Details of boy*/
#define EYE_WHITE_L  75  /*dimensions of eye*/
#define EYE_WHITE_R  15
#define EYE_BLUE     45

/* Chair details */
#define CHAIR_X   125
#define CHAIR_HT  190
#define CHAIR_WT  20

/* Railroad details */
#define RAIL_CENTER       -190
#define RAIL_WT           10
#define RAIL_HT_BOTTOM    RAIL_CENTER - 3
#define RAIL_HT_TOP       RAIL_CENTER + RAIL_WT + 3 

/* Height and width of a single train car */
#define TRAIN_HEIGHT 28
#define TRAIN_WIDTH  42

/* Girl location */
#define GIRL    50

/* Bomb Location */
#define BOMB_X  -120       
#define BOMB_Y  RAIL_HT_BOTTOM - 8

/* Tree Details */
#define TREE_HT  40
#define TREE_WT  30
#define TRUNK_HT  15

/* Window details */
#define PANE_HT  75
#define BTW_PANE 15

/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background, including the sun at coordinates sun_x and 
   sun_y */
void draw_landscape(int win_sun_x, int win_sun_y, int plane_x, 
					int plane_y, int boy, int train_x, 
					int move_train);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int car_direction[], int *car_color, int *nCar, 
				   int *train_move);

/* Update plane coordinates plane_x, plane_y for one tick */
void move_plane(int *plane_x, int *plane_y);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int nCar, int x[], int y[], int direction[], 
				  int speed);

/* Draw all vehicles given their current x, y coordinates and color*/
void draw_traffic(int nCar, int x[], int y[], int color);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color);

/* Display error message if internal error is detected. */
void something_is_wrong (void);

/*Draw peeking boy over table*/
void peeking_boy(int y);

/* Draw train */
void draw_train(int train_x);

/* Draw train crash */
void draw_crash();
/* Draw tree */
void draw_tree(int x_position, int y_position);

/* Update sun coordinates win_sun_x, win_sun_y by one tick */
void move_win_sun(int *win_sun_x, int *win_sun_y);

/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse 
	                           event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	/* Information about the plane: */
	int plane_x, plane_y;			/* screen x and y coordinates */

	/* Information about vehicles in the animation:							*/
	/* [Only one car now - will need to be changed to add more]				*/
	int nCar = 1;  /*Number of cars on road*/
	int car_x[MAX_TRAFFIC];  /*Initializing x-coord to 0*/
	int car_y[MAX_TRAFFIC];  /* current position of the car  */
	int car_direction[MAX_TRAFFIC];		/* current direction: 
	                                       +1=right, -1=left	*/
	int car_color;			/* color of the car								*/
	int car_speed;			/* speed in pixels per tick when          
	                           traffic moving	*/	
	int traffic_moving;		/* = "traffic is currently moving"				*/
	int boyY = HORIZON + 10;   /* Center of head*/
	int boyDir = -1;
	long i;                  /* counter for ()*/
	int train_x = -GP142_XMAX;     /* current position of train */
	int move_train = FALSE;     /* determine if train is in motion */
	
	/* Information about location of sun */
	int win_sun_x;
	int win_sun_y;


	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the plane */
	plane_x = GP142_XMAX - 50;
	plane_y = GP142_YMAX - 35;

	/* set initial location of the sun */
	win_sun_x = GP142_XMAX - 40;
	win_sun_y = GP142_YMAX - 50;

	/* set initial conditions for the car at random sides of screen*/
	for(i = 0; i < MAX_TRAFFIC; i++)
		{
		car_x[i] = -GP142_XMAX - CAR_WIDTH;
		if(rand() % 2) {
		car_y[i] = HIGHWAY_CENTER - 10;
		car_direction[i] = -1;
		}
		else{
		car_y[i] = HIGHWAY_CENTER;
		car_direction[i] = +1;
		}
	}
	car_speed = 5;
	car_color = RED;
	traffic_moving = TRUE;
	
	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(win_sun_x, win_sun_y, plane_x, plane_y, boyY,      
		           train_x, move_train);
	draw_buttons( );
	draw_traffic(nCar, car_x, car_y, car_color);
	

	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving, 
					          &car_speed, car_direction, &car_color, 
							  &nCar, &move_train);
			} else {
				/* insert code here (and additional else-if           
				   statements) */
				/* to react to mouse clicks elsewhere on the screen*/
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			
			if(boyY == -30)
				boyDir = -1;
			else if(boyY == -190)
			    boyDir = 1;

			if(boyDir == -1)
				boyY = boyY - 2;
			else if(boyDir == 1)
				boyY = boyY + 2;
            
			move_plane(&plane_x, &plane_y);
			
			move_win_sun(&win_sun_x, &win_sun_y);

			if (traffic_moving)
				move_traffic(nCar, car_x, car_y, car_direction, 
				             car_speed);                             
						
			/* train action */
			if (move_train == TRUE && train_x <= GIRL - 15)
			{
				train_x = train_x + 5;	

				GP142_printfXY(YELLOW, BOMB_X + 50, BOMB_Y - 17,      
					           12, "TOCK");
				GP142_flush();
			}
			else if (train_x > 0 && move_train == TRUE)
			{
				move_train = FALSE;
				train_x = -GP142_XMAX;
				draw_crash();
				for(i = 0; i < 2000000; i++){}
				for(i = 0; i < 2000000; i++){}
				for(i = 0; i < 2000000; i++){}
			}


			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(win_sun_x, win_sun_y, plane_x, plane_y, boyY,  
			           train_x, move_train);
		draw_buttons();
		draw_traffic(nCar, car_x, car_y, car_color);
		
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the plane at coordinates plane_x   
   and plane_y */
void draw_landscape(int win_sun_x, int win_sun_y, int plane_x, 
					int plane_y, int boy, int train_x, 
					int move_train)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of       
	                                       text */
	int text_size   = 12;				/* size of text font */
	int i;                              /* counter for()*/
	int x_position;                    /* position of tree x-coord */
	int y_position;                    /* position of tree y-coord */

	/* Draw the wall */
	GP142_rectangleXY(BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	

	/* Draw the window */
	GP142_rectangleXY(ICE_BLUE, GP142_XMAX / 3 + PANE_HT * 2 + 
		              BTW_PANE * 3, HORIZON + 5, GP142_XMAX / 3, 
					  HORIZON + 5 + PANE_HT * 3 + BTW_PANE * 4, 
					  FILL);
	
		/* Draw the sun */
		GP142_circleXY(YELLOW, win_sun_x, win_sun_y, 13);
	
	GP142_lineXY(WHITE, GP142_XMAX / 3, HORIZON + 5, GP142_XMAX / 3, 
		         HORIZON + 5 + PANE_HT * 3 + BTW_PANE * 4, 10);
	GP142_lineXY(WHITE, GP142_XMAX / 3 + PANE_HT + BTW_PANE * 2, 
		         HORIZON + 5, GP142_XMAX / 3 + PANE_HT + BTW_PANE * 
				 2, HORIZON + 5 + PANE_HT * 3 + BTW_PANE * 4, 10);
	GP142_lineXY(WHITE, GP142_XMAX / 3 + PANE_HT * 2 + BTW_PANE * 3,
		         HORIZON + 5, GP142_XMAX / 3 + PANE_HT * 2 + BTW_PANE
				 * 3, HORIZON + 5 + PANE_HT * 3 + BTW_PANE * 4, 10);
	GP142_lineXY(WHITE, GP142_XMAX / 3, HORIZON + 5, GP142_XMAX / 3 
		         + PANE_HT * 2 + BTW_PANE * 3, HORIZON + 5, 10);
	GP142_lineXY(WHITE, GP142_XMAX / 3, HORIZON + 5 + PANE_HT + 
		         BTW_PANE * 2, GP142_XMAX / 3 + PANE_HT * 2 + 
				 BTW_PANE * 3, HORIZON + 5 + PANE_HT + BTW_PANE 
				 * 2, 10);
	GP142_lineXY(WHITE, GP142_XMAX / 3, HORIZON + 5 + PANE_HT * 2 + 
		         BTW_PANE * 3, GP142_XMAX / 3 + PANE_HT * 2 + 
				 BTW_PANE * 3, HORIZON + 5 + PANE_HT * 2 + BTW_PANE 
				 * 3, 10);
	GP142_lineXY(WHITE, GP142_XMAX / 3, HORIZON + 5 + PANE_HT * 3 + 
		         BTW_PANE * 4, GP142_XMAX / 3 + PANE_HT * 3 + 
				 BTW_PANE * 4, HORIZON + 5 + PANE_HT * 3 + BTW_PANE
				 * 4, 10);
	GP142_rectangleXY(BLUE, 0, -GP142_YMAX, GP142_XMAX / 3 - 5, 
		              GP142_YMAX, FILL);

	/* Draw the chair */
	GP142_rectangleXY(BROWN, -CHAIR_X, HORIZON, -CHAIR_X + CHAIR_WT,
		              HORIZON + CHAIR_HT, FILL);  
	GP142_rectangleXY(BROWN, CHAIR_X, HORIZON, CHAIR_X + CHAIR_WT, 
		              HORIZON + CHAIR_HT, FILL);
	GP142_rectangleXY(BROWN, -CHAIR_X, CHAIR_HT / 3, CHAIR_X, 
		              CHAIR_HT / 3 - CHAIR_WT, FILL);
	GP142_circleXY(BROWN, -CHAIR_X + CHAIR_WT / 2, HORIZON + 
		           CHAIR_HT, CHAIR_WT);
	GP142_circleXY(BROWN, CHAIR_X + CHAIR_WT / 2, HORIZON + 
		           CHAIR_HT, CHAIR_WT);

	/* Draw the paper airplane */
	GP142_triangleXY(WHITE, plane_x + 45, plane_y, plane_x - 45, 
		             plane_y, plane_x + 45, plane_y + 30, FILL);
	GP142_triangleXY(BLACK, plane_x + 45, plane_y, plane_x - 45, 
		             plane_y, plane_x + 45, plane_y + 30, 1);
	GP142_triangleXY(WHITE, plane_x + 45, plane_y, plane_x - 45, 
		             plane_y, plane_x + 55, plane_y + 20, FILL);
	GP142_triangleXY(BLACK, plane_x + 45, plane_y, plane_x - 45, 
		             plane_y, plane_x + 55, plane_y + 20, 1);

	/* Draw the boy*/
	peeking_boy(boy);
	
	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);
	GP142_lineXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER, GP142_XMAX,
		         HIGHWAY_CENTER, 3);
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.");
	
	/* Draw houses */
	GP142_rectangleXY(FOREST_GREEN, 240, HORIZON - 30, 180, HORIZON 
		              + 20, FILL);
	GP142_rectangleXY(NAVY_BLUE, 200, HORIZON - 30, 215, HORIZON, 
		              FILL);
	GP142_rectangleXY(NAVY_BLUE, 220, HORIZON - 15, 235, HORIZON, 
		              FILL);
	GP142_triangleXY(GOLD, 245, HORIZON + 20, 175, HORIZON + 20, 210,
		             HORIZON + 40, FILL);

	GP142_rectangleXY(ORANGE, -230, HORIZON - 35, -175, HORIZON + 30,
		              FILL);
	GP142_rectangleXY(FOREST_GREEN, -220, HORIZON - 35, -205, 
		              HORIZON, FILL);
	GP142_rectangleXY(FOREST_GREEN, -200, HORIZON, -185, HORIZON + 
		              15, FILL);
	GP142_triangleXY(NAVY_BLUE, -235, HORIZON + 30, -170, HORIZON + 
		             30, -203, HORIZON + 55, FILL);

	GP142_rectangleXY(RED, -150, HORIZON + 20, -90, HORIZON - 25, 
		              FILL);
	GP142_rectangleXY(NAVY_BLUE, -140, HORIZON, -125, HORIZON -25, 
		              FILL);
	GP142_rectangleXY(NAVY_BLUE, -115, HORIZON + 10, -95, HORIZON - 
		              5, FILL);
	GP142_triangleXY(GOLD, -155, HORIZON + 20, -85, HORIZON + 20, 
		             -115, HORIZON + 35, FILL);
	GP142_lineXY(BLACK, -GP142_XMAX, RAIL_CENTER, GP142_XMAX, 
		         RAIL_CENTER, 3);
	GP142_lineXY(BLACK, -GP142_XMAX, RAIL_CENTER + RAIL_WT, 
		         GP142_XMAX, RAIL_CENTER +RAIL_WT, 3);
	for(i = -GP142_XMAX; i <= GP142_XMAX; i = i + 5)
		GP142_lineXY(BLACK, i, RAIL_HT_BOTTOM, i, RAIL_HT_TOP, 3);   

	/* Draw sign */
	GP142_lineXY(BLACK, 200, RAIL_CENTER + 7/3 * RAIL_WT, 200, 
		         RAIL_CENTER + 5 * RAIL_WT, 4);
	GP142_rectangleXY(DUSTY_PLUM, 150, RAIL_CENTER + 3 * RAIL_WT,    
		              250, RAIL_CENTER + 7 * RAIL_WT, FILL);
	GP142_rectangleXY(BLACK, 150, RAIL_CENTER + 3 * RAIL_WT, 250, 
		              RAIL_CENTER + 7 * RAIL_WT, 2);                 
	GP142_printfXY(BLACK, 156, RAIL_CENTER + 5 * RAIL_WT, 13, 
		           "MICRO-WORLD");                                   
			
	/* Draw trees */
	x_position = 60;
	y_position = -150;
	draw_tree(x_position, y_position);
	x_position = -100;
	y_position = -160;
	draw_tree(x_position, y_position);
	x_position = -76;
	y_position = HORIZON - 15;
	draw_tree(x_position, y_position);
	x_position = -GP142_XMAX + 25;
	y_position = -GP142_YMAX + 6;
	draw_tree(x_position, y_position);
	x_position = GP142_XMAX - 35;
	y_position = -GP142_YMAX + 9;
	draw_tree(x_position, y_position);
	x_position = -GP142_XMAX + 20;
	y_position = HORIZON - 20;
	draw_tree(x_position, y_position);
	x_position = GP142_XMAX - 15;
	y_position = HORIZON - 9;
	draw_tree(x_position, y_position);
    if(move_train)
	draw_train(train_x);
	
} /*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in 
	                                   button */                     
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "New Color");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "More Traffic");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "AmTrak");
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int car_direction[], int *car_color, int *nCar, 
				   int *train_move)
{
	int buttonNum;  /*Number of selected button*/
	int i;          /*Counter for()*/

	/* Complain if x coordinate couldn't be inside a button */       
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */
		*car_speed = *car_speed + 1;
		break;
	case 3:
		/* slow down */
		*car_speed = *car_speed - 1;
		if (*car_speed < 0)
			*car_speed = 0;
		break;
		
	case 4:
		/* reverse */
		for(i = 0; i < MAX_TRAFFIC; i++)
			car_direction[i] = -car_direction[i];
		break;
	case 5:
		/* change car color */
		*car_color = (*car_color+1) % MAX_COLORS;
		break;
	case 6:
		/*additional car*/
		if(*nCar < MAX_TRAFFIC)
		*nCar = *nCar + 1;
		break;
	case 7:
		/* train action */
		*train_move = TRUE;
		break;
	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update plane coordinates plane_x, plane_y by one tick */
void move_plane(int *plane_x, int *plane_y) {
	/* Move the plane to the left.  If it reaches the edge, move it*/
	/* to the other side and down a bit. */
	(*plane_x) = *plane_x - 3;
	if (*plane_x < -GP142_XMAX -30) {
		*plane_x = - *plane_x;
		(*plane_y) --;
	}
}

/* Update window sun coordinates win_sun_x, win_sun_y by one tick */
void move_win_sun(int *win_sun_x, int *win_sun_y){
	/* Move the sun to the left.  If it reaches the middle of screen,
	   move it to the other side and down a bit */                   
	(*win_sun_x) --;
	if (*win_sun_x < 30) {
		*win_sun_x = GP142_XMAX + 5;
		(*win_sun_y) --;
	}
}

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int nCar, int x[], int y[], int direction[], 
				  int speed) {                                       
	/* Note: If there is more than one vehicle, this should */
	/* be updated to adjust all vehicle coordinates */

	int trial_x[MAX_TRAFFIC];		/* new value for x coordinate */
	int i;      /*Counter for()*/

	/* move vehicles.  If it moves off the edge, begin at opposite 
	   screen */
	for(i=0; i < nCar; i++)
	{
	trial_x[i] = x[i] + (direction[i] * speed);
	if (abs(trial_x[i]) > GP142_XMAX + CAR_WIDTH)
		x[i] = - trial_x[i];
	else
		x[i] = trial_x[i];
	}
}


/* Draw all vehicles given their current x, y coordinates and color*/
void draw_traffic(int nCar, int x[], int y[], int color) {

	int i;   /*Counter for()*/

	for(i = 0; i < nCar; i++)
		draw_car(x[i],y[i],color);


}



/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color) {
	GP142_rectangleXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH/2, y + CAR_HEIGHT*3/4, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH/6, y + CAR_HEIGHT*3/4,
						x + CAR_WIDTH/6, y + CAR_HEIGHT, FILL);
	GP142_circleXY(BLACK, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, 
		           CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, 
		           CAR_HEIGHT/4);
}



/*****************************************************************************

     OTHER

*****************************************************************************/


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}



/*******************************************************************

  Peeking Boy

*******************************************************************/

void peeking_boy(int y)
{

	int hair;
	/*Head of boy*/
	GP142_circleXY(CHALK, 0, y, 150);

	/*Hair*/
	for(hair = -100; hair < 100; hair += 5)
		GP142_lineXY(BLACK, hair, y + 100, hair, y + 125, 1);
	for(hair = -75; hair < 75; hair += 5)
		GP142_lineXY(BLACK, hair, y + 115, hair, y + 135, 1);
    for(hair = -55; hair < 55; hair += 5)
    	GP142_lineXY(BLACK, hair, y + 130, hair, y + 145, 1);
	for(hair = -40; hair < 40; hair +=5)
		GP142_lineXY(BLACK, hair, y + 140, hair, y + 150, 1);
	for(hair = -25; hair < 25; hair +=5)
		GP142_lineXY(BLACK, hair, y + 150, hair, y + 155, 1);        

	/*Facial Features*/
	GP142_ovalXY(WHITE, EYE_WHITE_L, y + 90, EYE_WHITE_R, y + 10, 
		         FILL);
	GP142_ovalXY(WHITE, -EYE_WHITE_L, y + 90, -EYE_WHITE_R, y + 10, 
		         FILL);
    GP142_ovalXY(BLACK, EYE_WHITE_L, y + 90, EYE_WHITE_R, y + 10, 1);
	GP142_ovalXY(BLACK, -EYE_WHITE_L, y + 90, -EYE_WHITE_R, y + 10, 
		         1);

	
	GP142_circleXY(NAVY_BLUE, EYE_BLUE, y + 30, 20);  
	GP142_circleXY(NAVY_BLUE, -EYE_BLUE, y + 30, 20);

	GP142_circleXY(ORANGE, 85, y - 5, 3);
	GP142_circleXY(ORANGE, -82, y - 10, 3);
	GP142_circleXY(ORANGE, 77, y - 5, 3);
	GP142_circleXY(ORANGE, 63, y - 4, 3);
	GP142_circleXY(ORANGE, -60, y - 8, 3);

	/*Nose*/
	GP142_ovalXY(BLACK, 30, y + 10 , -30, y - 10, 1);


}

/*******************************************************************

  Draw Trains

  ******************************************************************/

void draw_train(int train_x)
{

	int text_size = 12;

	GP142_rectangleXY(NAVY_BLUE, train_x, RAIL_CENTER + 6, train_x - 
		              TRAIN_WIDTH, RAIL_CENTER + 3 + TRAIN_HEIGHT, 
					  FILL);  
	GP142_circleXY(BLACK, train_x, RAIL_CENTER + 6, 6);
	GP142_circleXY(BLACK, train_x - TRAIN_WIDTH, RAIL_CENTER + 6, 6);

	/*Second Car */
	GP142_rectangleXY(PURPLE, train_x - TRAIN_WIDTH * 4/3, 
		              RAIL_CENTER + 6, train_x - TRAIN_WIDTH - 
					  TRAIN_WIDTH * 4/3, RAIL_CENTER + TRAIN_HEIGHT, 
					  FILL);
	GP142_circleXY(BLACK, train_x - TRAIN_WIDTH * 4/3, RAIL_CENTER 
		           + 6, 6);
	GP142_circleXY(BLACK, train_x - TRAIN_WIDTH - TRAIN_WIDTH * 4/3,
		           RAIL_CENTER + 6, 6);

	/* Third Car */
	GP142_rectangleXY(SEA_GREEN, train_x - TRAIN_WIDTH * 4/3 - 
		              TRAIN_WIDTH * 4/3, RAIL_CENTER + 6, 
					  train_x - TRAIN_WIDTH - TRAIN_WIDTH * 4/3 - 
					  TRAIN_WIDTH * 5/3, RAIL_CENTER + TRAIN_HEIGHT 
					  + 3, FILL); 
	GP142_circleXY(BLACK, train_x - TRAIN_WIDTH * 4/3 - TRAIN_WIDTH 
		           * 4/3, RAIL_CENTER + 6, 6);
	GP142_circleXY(BLACK, train_x - TRAIN_WIDTH - TRAIN_WIDTH * 4/3 
		           - TRAIN_WIDTH * 5/3, RAIL_CENTER + 6, 6);
	GP142_printfXY(BLACK, train_x - TRAIN_WIDTH - TRAIN_WIDTH * 4/3 
		           - TRAIN_WIDTH * 5/3 + 2, RAIL_CENTER + 18, 8, 
				   "FLAMMABLE");

	/* Fourth Car */
	GP142_rectangleXY(MAGENTA, train_x - TRAIN_WIDTH * 4/3 - 
		              TRAIN_WIDTH * 4/3 - TRAIN_WIDTH * 5/3, 
					  RAIL_CENTER + 6, train_x - TRAIN_WIDTH * 4/3 - 
					  TRAIN_WIDTH * 5/3 - TRAIN_WIDTH * 5/2, 
					  RAIL_CENTER + TRAIN_HEIGHT - 2, FILL);
	GP142_circleXY(BLACK, train_x - TRAIN_WIDTH * 4/3 - TRAIN_WIDTH * 
		           4/3 - TRAIN_WIDTH * 5/3, RAIL_CENTER + 6, 6);
	GP142_circleXY(BLACK, train_x - TRAIN_WIDTH * 4/3 - TRAIN_WIDTH * 
		           5/3 - TRAIN_WIDTH * 5/2, RAIL_CENTER + 6, 6);

	/* Draw damsil in distress */
	GP142_circleXY(YELLOW, GIRL, RAIL_CENTER + RAIL_WT + 15, 9); 
	GP142_lineXY(CHALK, GIRL - 8, RAIL_CENTER + RAIL_WT, GIRL + 8, 
		         RAIL_CENTER + RAIL_WT, 4);
	GP142_lineXY(CHALK, GIRL - 3, RAIL_CENTER - 3, GIRL - 3, 
		         RAIL_CENTER - 10, 4);
	GP142_lineXY(CHALK, GIRL + 3, RAIL_CENTER - 3, GIRL + 3, 
		         RAIL_CENTER - 10, 4);
	GP142_triangleXY(PINK, GIRL, RAIL_CENTER + RAIL_WT + 6, GIRL - 
		             10, RAIL_CENTER - 6, GIRL + 10, RAIL_CENTER - 6,
					 FILL);
	GP142_lineXY(MED_GRAY, GIRL - 7, RAIL_CENTER + RAIL_WT - 2, GIRL 
		         + 7, RAIL_CENTER + RAIL_WT - 2, 3);
	GP142_lineXY(MED_GRAY, GIRL - 7, RAIL_CENTER + RAIL_WT - 7, GIRL 
		         + 7, RAIL_CENTER + RAIL_WT - 7, 3);
	GP142_lineXY(MED_GRAY, GIRL - 7, RAIL_CENTER + RAIL_WT - 12, GIRL
		         + 7, RAIL_CENTER + RAIL_WT - 12, 3);
	GP142_printfXY(BLACK, GIRL + 14, RAIL_CENTER + RAIL_WT + 18, 
		           text_size, "HELP!");

	/* Draw bomb */
	GP142_circleXY(BLACK, BOMB_X, BOMB_Y, 9);
	GP142_lineXY(BLACK, BOMB_X + 15, BOMB_Y + 8, BOMB_X, BOMB_Y, 4);
	GP142_triangleXY(RED, BOMB_X + 15, BOMB_Y + 16, BOMB_X + 12, 
		             BOMB_Y + 4, BOMB_X + 19, BOMB_Y + 7, FILL);
	GP142_triangleXY(ORANGE, BOMB_X + 15, BOMB_Y + 16, BOMB_X + 12, 
		             BOMB_Y + 4, BOMB_X + 19, BOMB_Y + 7, 2);
	GP142_triangleXY(YELLOW, BOMB_X + 15, BOMB_Y + 16, BOMB_X + 12, 
		             BOMB_Y + 4, BOMB_X + 19, BOMB_Y + 7, 1);
	GP142_printfXY(RED, BOMB_X + 15, BOMB_Y - 15, text_size, "TIC");	




}

void draw_crash()
{
	int x;
	int y;

	GP142_rectangleXY(RED, -GP142_XMAX, GP142_YMAX, GP142_XMAX, 
		              -GP142_YMAX, FILL);
	GP142_flush();
	for(x = -GP142_XMAX; x < GP142_XMAX; x += 200)
	  for(y = GP142_YMAX; y > -GP142_YMAX; y -= 50)
	  {
	    GP142_printfXY(BLACK, x, y, 40, "!!!BOOM!!!");
	    GP142_flush();
	  }

}


/*****************************************************************

  Draw Trees

  ****************************************************************/

void draw_tree(int x_position, int y_position)
{
	GP142_lineXY(GOLD, x_position, y_position, x_position, y_position
		         - TRUNK_HT, 4);
	GP142_triangleXY(FOREST_GREEN, x_position - TREE_WT / 2, 
		             y_position, x_position + TREE_WT / 2, 
					 y_position, x_position, y_position + TREE_HT, 
					 FILL);

}




